﻿using GalaSoft.MvvmLight;
using System;

namespace PhotoBrowser.Model
{
    public class Photo : ObservableObject
    {
        public Uri ImageUri { get; set; }
        public Uri ThumbnailUri { get; set; }
        public string DisplayName { get; set; }
        public string Category { get; set; }

        private int _likesCount = 0;
        public int LikesCount
        {
            get { return _likesCount; }
            set
            {
                Set<int>(
                    () => LikesCount,
                    ref _likesCount, value);
            }
        }

        private int _dislikesCount = 0;
        public int DislikesCount
        {
            get { return _dislikesCount; }
            set
            {
                Set<int>(
                    () => DislikesCount,
                    ref _dislikesCount, value);
            }
        }

        private double _rotationAngle = 0.0;
        public double RotationAngle 
        {
            get { return _rotationAngle; }
            set
            {
                Set<double>(
                    () => RotationAngle, 
                    ref _rotationAngle, value);
            }
        }
    }
}
