﻿using System;
using System.Linq;
using Windows.UI.Core;
using Windows.UI.ViewManagement;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;

namespace PhotoBrowser.Common
{
    public class LayoutAwarePage : Page
    {
        public LayoutAwarePage()
        {
            Window.Current.SizeChanged += this.WindowSizeChanged;

            Loaded += LayoutAwarePage_Loaded;
        }

        void LayoutAwarePage_Loaded(object sender, RoutedEventArgs e)
        {
            InvalidateVisualState();
        }

        private void WindowSizeChanged(object sender, WindowSizeChangedEventArgs e)
        {
            this.InvalidateVisualState();
        }

        protected virtual string DetermineVisualState(ApplicationViewState viewState)
        {
            return viewState.ToString();
        }

        public void InvalidateVisualState()
        {
            string visualState = DetermineVisualState(ApplicationView.Value);

            VisualStateManager.GoToState(this, visualState, false);
        }
    }
}
