﻿using PhotoBrowser.Common;
using PhotoBrowser.Model;
using PhotoBrowser.ViewModel;
using System.Diagnostics;
using Windows.UI.ViewManagement;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Navigation;

namespace PhotoBrowser
{
    public sealed partial class MainPage : LayoutAwarePage
    {
        private MainViewModel _vm = new MainViewModel();

        public MainPage()
        {
            this.InitializeComponent();

            DataContext = _vm;
        }

        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            _vm.LoadPhotos();

            var cvs = Resources["PhotoSource"] as CollectionViewSource;

            SemanticZoomedOutView.ItemsSource =
                cvs.View.CollectionGroups;

            SnappedViewItems.ItemsSource =
                cvs.View.CollectionGroups;
        }

        private void Image_ImageFailed_1(object sender, ExceptionRoutedEventArgs e)
        {
            Debug.WriteLine(e.ErrorMessage);
        }

        private void OnCategoryHeaderClick(object sender, RoutedEventArgs e)
        {
            var category = 
                (sender as FrameworkElement).DataContext as PhotoCategory;

            var browserViewModel = new CategoryBrowserViewModel();
            browserViewModel.AllCategories = _vm.Photos;
            browserViewModel.Category = category;

            this.Frame.Navigate(
                typeof(CategoryBrowserPage),
                browserViewModel);
        }
    }
}
