﻿using PhotoBrowser.Common;
using PhotoBrowser.Model;
using PhotoBrowser.ViewModel;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace PhotoBrowser
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class SearchResultsPage : LayoutAwarePage
    {
        private SearchViewModel _vm;

        public SearchResultsPage()
        {
            this.InitializeComponent();

            _vm = new SearchViewModel();
            DataContext = _vm;
        }

        private void OnBackButtonClick(object sender, Windows.UI.Xaml.RoutedEventArgs e)
        {
            Frame.GoBack();
        }

        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            string queryText = e.Parameter as string;

            _vm.QueryText = queryText;            
        }

        private void SearchResultsView_ItemClick(object sender, ItemClickEventArgs e)
        {
            var photo = e.ClickedItem as Photo;

            var vm = _vm.ConstructCategoryBrowserViewModel(photo);

            Frame.Navigate(typeof(CategoryBrowserPage), vm);
        }
    }
}
