﻿using PhotoBrowser.Model;
using System;
using Windows.Data.Xml.Dom;
using Windows.UI.Notifications;

namespace PhotoBrowser.Services
{
    public class ToastNotificationService
    {
        private static ToastNotificationService _current;
        public static ToastNotificationService Current
        {
            get
            {
                if (_current == null)
                    _current = new ToastNotificationService();

                return _current;
            }
        }


        public async void NotifyCategoryDeleted(PhotoCategory category)
        {
            var toastXml = ToastNotificationManager.GetTemplateContent
                (ToastTemplateType.ToastImageAndText02);

            var imageElement = toastXml.GetElementsByTagName("image")[0];
            var headingTextElement = toastXml.GetElementsByTagName("text")[0];
            var bodyTextElement = toastXml.GetElementsByTagName("text")[1];

            string heading = "Exterminated " + category.Category;
            string bodyTemplate = "ZOMG! {0} deleted every image in the category!";

            string userFirstName = 
                await Windows.System.UserProfile.UserInformation.GetFirstNameAsync();

            string bodyText = string.Format(bodyTemplate, userFirstName);

            headingTextElement.AppendChild(
                toastXml.CreateTextNode(heading));

            bodyTextElement.AppendChild(
                toastXml.CreateTextNode(bodyText));

            if (category.Photos.Count > 0)
            {
                var thumbnail = category.Photos[0].ThumbnailUri.ToString();
                ((XmlElement)imageElement).SetAttribute("src", thumbnail);
            }

            var toastElement = toastXml.SelectSingleNode("/toast");
            var launchParams = "deletedCategory";
            ((XmlElement)toastElement).SetAttribute("duration", "long");
            ((XmlElement)toastElement).SetAttribute("launch", launchParams);


            var toast = new ToastNotification(toastXml);
            var notifier = ToastNotificationManager.CreateToastNotifier();
            notifier.Show(toast);
        }
 
    }
}
