﻿using GalaSoft.MvvmLight;
using System;
using System.Linq;
using Windows.ApplicationModel.DataTransfer;
using Windows.ApplicationModel.DataTransfer.ShareTarget;

namespace PhotoBrowser.ViewModel
{
    public class ShareTargetViewModel : ViewModelBase
    {
        private ShareOperation _operation;

        public ShareTargetViewModel(ShareOperation operation)
        {
            _operation = operation;

            ProcessOperation();
        }

        private async void ProcessOperation()
        {
            if (_operation.Data.AvailableFormats.Contains(StandardDataFormats.Text))
            {
                Text = await _operation.Data.GetTextAsync();
                ApplicationName = _operation.Data.Properties.ApplicationName;
                ApplicationListingUri = _operation.Data.Properties.ApplicationListingUri;
                Description = _operation.Data.Properties.Description;
                Title = _operation.Data.Properties.Title;
            }                      
        }

        private string _text;
        public string Text
        {
            get { return _text; }
            private set { Set<string>(() => Text, ref _text, value); }
        }

        private string _applicationName;
        public string ApplicationName
        {
            get { return _applicationName; }
            private set { Set<string>(() => ApplicationName, ref _applicationName, value); }
        }

        private Uri _applicationListingUri;
        public Uri ApplicationListingUri
        {
            get { return _applicationListingUri; }
            private set { Set<Uri>(() => ApplicationListingUri, ref _applicationListingUri, value); }
        }

        private string _description;
        public string Description
        {
            get { return _description; }
            private set { Set<string>(() => Description, ref _description, value); }
        }

        private string _title;
        public string Title
        {
            get { return _title; }
            private set { Set<string>(() => Title, ref _title, value); }
        }

    }
}
