﻿using System.Collections.ObjectModel;
using System.ComponentModel;
using NetworkingClient.Model;

namespace NetworkingClient.ViewModels
{
    class MainViewModel : INotifyPropertyChanged
    {
        private ObservableCollection<InstantMessage> _messages = 
            new ObservableCollection<InstantMessage>();
        
        public ObservableCollection<InstantMessage> Messages        
        {
            get { return _messages; }
            set
            {
                if (_messages != value)
                {
                    _messages = value;
                    NotifyPropertyChanged("Messages");
                }
            }
        }


        public async void LoadMessages()
        {
            var client = new Services.MessageServiceClient();

            var response = await client.GetMessagesAsync();

            Messages = response;
        }

        public event PropertyChangedEventHandler PropertyChanged;

        protected void NotifyPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
