﻿using System;
using NetworkingClient.ViewModels;
using Windows.UI.Popups;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Navigation;

namespace NetworkingClient
{
    public sealed partial class MainPage : Page
    {
        private MainViewModel _vm = new MainViewModel();

        public MainPage()
        {
            this.InitializeComponent();
            DataContext = _vm;
        }

        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
        }

        private void OnLoadDataClick(object sender, RoutedEventArgs e)
        {
            _vm.LoadMessages();
        }

        private void OnAddItemClick(object sender, RoutedEventArgs e)
        {
            _vm.AddMessage();
        }

        private async void ShowSelectSomethingMessage()
        {
            var dlg = new MessageDialog(
                "Please select a message before selecting this option.",
                "Messages");

            await dlg.ShowAsync();
        }

        private void OnUpdateItemClick(object sender, RoutedEventArgs e)
        {
            if (_vm.SelectedMessage != null)
                _vm.UpdateSelectedMessage();
            else
                ShowSelectSomethingMessage();
        }

        private async void OnDeleteItemClick(object sender, RoutedEventArgs e)
        {
            if (_vm.SelectedMessage != null)
            {
                var dlg = new MessageDialog(
                    "As you sure you want to delete the selected message from '" + 
                        _vm.SelectedMessage.From + "'?",
                    "Delete");

                var yesCommand = new UICommand("Yes");
                var noCommand = new UICommand("No");
                dlg.Commands.Add(yesCommand);
                dlg.Commands.Add(noCommand);

                var cmd = await dlg.ShowAsync();

                if (cmd == yesCommand)
                    _vm.DeleteSelectedMessage();
            }
        }

    }
}
