﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using NetworkingClient.Model;

namespace Site.Controllers
{
    public class MessagesController : ApiController
    {
        private static List<InstantMessage> _data = 
            new List<InstantMessage>() 
            { 
                new InstantMessage() { From="Pilot", To="CapAvatar", 
                    Text="A message from the Gamilon ship, sir:", 
                    Timestamp=DateTime.Parse("6/1/2012 2:57pm"), Id=1 },
                new InstantMessage() { From="Pilot", To="CapAvatar", 
                    Text="'Earth fleet, we advise you to surrender now'", 
                    Timestamp=DateTime.Parse("6/1/2012 2:58pm"), Id=2 },
                new InstantMessage() { From="Pilot", To="CapAvatar", 
                    Text="What shall I tell them?", 
                    Timestamp=DateTime.Parse("6/1/2012 2:59pm"), Id=3 },
                new InstantMessage() { From="CapAvatar", To="Pilot", 
                    Text="Tell them they're idiots!", 
                    Timestamp=DateTime.Parse("6/1/2012 3:00pm"), Id=4 },
            };

        // GET api/messages
        public IEnumerable<InstantMessage> Get()
        {
            return _data;
        }

        // GET api/messages/5
        public InstantMessage Get(int id)
        {
            return _data.Where(m => m.Id == id).FirstOrDefault();
        }

        // POST api/messages
        public void Post(InstantMessage value)
        {
            bool exists = (_data.Where(im => im.Id == value.Id).FirstOrDefault() != null);

            if (!exists)
            {
                _data.Add(value);
            }
        }

        // PUT api/messages/5
        public void Put(int id, InstantMessage value)
        {
            var item = _data.Where(im => im.Id == value.Id).FirstOrDefault();

            if (item != null)
            {
                item.Text = value.Text;
                item.Timestamp = value.Timestamp;
                item.To = value.To;
                item.From = value.From;
            }
        }

        // DELETE api/messages/5
        public void Delete(int id)
        {
            var item = _data.Where(im => im.Id == id).FirstOrDefault();

            if (item != null)
                _data.Remove(item);
        }
    }
}
