﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SocketApp.Services
{

    public interface IMessageService
    {
        void Connect(string address);
        void Disconnect();
        void Listen();

        void SendEnlistment(double finalX, double finalY, double angle, string name, byte[] image);

        void SendTextMessage(double finalX, double finalY, double angle, string message);

        void SendStartRotateCounterClockwise(double finalX, double finalY, double angle);
        void SendStartRotateClockwise(double finalX, double finalY, double angle);
        void SendStopRotating(double finalX, double finalY, double angle);

        void SendStartMoveForward(double finalX, double finalY, double angle);
        void SendStartMoveBackward(double finalX, double finalY, double angle);
        void SendStopMoving(double finalX, double finalY, double angle);

        event EventHandler<MessageReceivedEventArgs> MessageReceived;
        event EventHandler<ConnectionReceivedEventArgs> ConnectionReceived;
    }


}
