﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SocketApp.Services
{
    public class MessageReceivedEventArgs : EventArgs
    {
        public MessageType MessageType { get; set; }
        public double XPosition { get; set; }
        public double YPosition { get; set; }
        public double Angle { get; set; }

        public string FromAddress { get; set; }

        public string Text { get; set; }
        public byte[] Image { get; set; }

        public MessageReceivedEventArgs(MessageType messageType, string fromAddress, double X, double Y, double angle)
        {
            MessageType = messageType;
            FromAddress = fromAddress;

            XPosition = X;
            YPosition = Y;
            Angle = angle;

            Text = string.Empty;
            Image = null;
        }

        public MessageReceivedEventArgs(MessageType messageType, string fromAddress, double X, double Y, double angle, string text)
        {
            MessageType = messageType;
            FromAddress = fromAddress;

            XPosition = X;
            YPosition = Y;
            Angle = angle;

            Text = text;
            Image = null;
        }

        public MessageReceivedEventArgs(MessageType messageType, string fromAddress, double X, double Y, double angle, string name, byte[] image)
        {
            MessageType = messageType;
            FromAddress = fromAddress;

            XPosition = X;
            YPosition = Y;
            Angle = angle;

            Text = name;
            Image = image;
        }
    }
}
