﻿using GalaSoft.MvvmLight;
using GalaSoft.MvvmLight.Threading;
using System;
using System.Linq;
using Windows.UI.Xaml.Media;

namespace SocketApp.Model
{
    public class Player : ObservableObject
    {
        private string _name; 
        public string Name 
        {
            get { return _name; }
            set { Set<string>(() => Name, ref _name, value); }
        }

        private SolidColorBrush _color;
        public SolidColorBrush Color
        {
            get { return _color; }
            set { Set<SolidColorBrush>(() => Color, ref _color, value); }
        }

        private PlayerLocation _location = new PlayerLocation();
        public PlayerLocation Location
        {
            get { return _location; }
            set 
            {
                DispatcherHelper.CheckBeginInvokeOnUI(() =>
                    {
                        Set<PlayerLocation>(() => Location, ref _location, value);
                    });
            }
        }
    }
}
